using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace VCD_Simple_Property
{
    public partial class Form1 : Form
    {


        private TIS.Imaging.VCDSwitchProperty _autoRoiEnable;
        private TIS.Imaging.VCDRangeProperty _focusValue;
        private TIS.Imaging.VCDRangeProperty _focusMaxValue;
        private TIS.Imaging.VCDRangeProperty _focusMinValue;
        private TIS.Imaging.VCDRangeProperty _autoRoiRight;
        private TIS.Imaging.VCDRangeProperty _autoRoiLeft;
        private TIS.Imaging.VCDRangeProperty _autoRoiTop;
        private TIS.Imaging.VCDRangeProperty _autoRoiBottom;

        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load( object sender, EventArgs e )
        {

            if( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                return;
            }


            //Jo͂ꂽfIC Imaging Contorol̃Rg[\TCYɂ
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.Size;



            //tH[JXl
            _focusValue = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_Value);
            if( _focusValue == null )
            {
                FocusValueTrackBar.Enabled = false;
            }
            else
            {
                FocusValueTrackBar.Enabled = true;
                FocusValueTrackBar.Minimum = _focusValue.RangeMin;
                FocusValueTrackBar.Maximum = _focusValue.RangeMax;
                FocusValueTrackBar.Value = _focusValue.Value;
                FocusValueTrackBar.TickFrequency = (FocusValueTrackBar.Maximum - FocusValueTrackBar.Minimum) / 10;
                FocusValueValueLabel.Text = FocusValueTrackBar.Value.ToString();
            }
            //tH[JXŏl
            _focusMinValue = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoMinValue);
            if (_focusMinValue == null)
            {
                FocusAutoMinValueTrackBar.Enabled = false;
            }
            else
            {
                FocusAutoMinValueTrackBar.Enabled = true;
                FocusAutoMinValueTrackBar.Minimum = _focusMinValue.RangeMin;
                FocusAutoMinValueTrackBar.Maximum = _focusMinValue.RangeMax;
                FocusAutoMinValueTrackBar.Value = _focusMinValue.Value;
                FocusAutoMinValueTrackBar.TickFrequency = (FocusAutoMinValueTrackBar.Maximum - FocusAutoMinValueTrackBar.Minimum) / 10;
                FocusAutoMinValueLabel.Text = _focusMinValue.Value.ToString();
            }

            //tH[JXől
            _focusMaxValue = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoMaxValue);
            if (_focusMaxValue == null)
            {
                FocusAutoMaxValuetrackBar.Enabled = false;
            }
            else
            {
                FocusAutoMaxValuetrackBar.Enabled = true;
                FocusAutoMaxValuetrackBar.Minimum = _focusMaxValue.RangeMin;
                FocusAutoMaxValuetrackBar.Maximum = _focusMaxValue.RangeMax;
                FocusAutoMaxValuetrackBar.Value = _focusMaxValue.Value;
                FocusAutoMaxValuetrackBar.TickFrequency = (FocusAutoMaxValuetrackBar.Maximum - FocusAutoMaxValuetrackBar.Minimum) / 10;
                FocusAutoMaxValueLabel.Text = _focusMaxValue.Value.ToString();
            }
            //ROI@\̗L̐ݒ
            _autoRoiEnable = icImagingControl1.VCDPropertyItems.Find<VCDSwitchProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoRoiEnable);
            if (_autoRoiEnable == null)
            {
                AutoRoiEnableCheckBox.Enabled = false;
                AutoFocusOnePushButton.Enabled = false;
            }
            else
            {
                _autoRoiEnable.Switch = false;
            }

            //I[gtH[JX Right
            _autoRoiRight = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoRoiRight );
            if( _autoRoiRight == null )
            {
                AutoRoiRightTrackBar.Enabled = false;
            }
            else
            {
                AutoRoiRightTrackBar.Enabled = true;
                AutoRoiRightTrackBar.Minimum = _autoRoiRight.RangeMin;
                AutoRoiRightTrackBar.Maximum = _autoRoiRight.RangeMax;
                AutoRoiRightTrackBar.Value = _autoRoiRight.Value;
                AutoRoiRightTrackBar.TickFrequency = (AutoRoiRightTrackBar.Maximum - AutoRoiRightTrackBar.Minimum) / 10;
                AutoRoiRightLabel.Text = _autoRoiRight.Value.ToString();
            }

            // I[gtH[JX Left
            _autoRoiLeft = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoRoiLeft);
            if(_autoRoiLeft == null )
            {
                AutoRoiLeftTrackBar.Enabled = false;
            }
            else
            {
                AutoRoiLeftTrackBar.Enabled = false;
                AutoRoiLeftTrackBar.Enabled = true;
                AutoRoiLeftTrackBar.Minimum = _autoRoiLeft.RangeMin;
                AutoRoiLeftTrackBar.Maximum = _autoRoiLeft.RangeMax;
                AutoRoiLeftTrackBar.Value = _autoRoiLeft.Value;
                AutoRoiLeftTrackBar.TickFrequency = (AutoRoiLeftTrackBar.Maximum - AutoRoiLeftTrackBar.Minimum) / 10;
                AutoRoiLeftLabel.Text = _autoRoiLeft.Value.ToString();
            }

            //I[gtH[JX@Top
            _autoRoiTop = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoRoiTop);
            if (_autoRoiTop == null)
            {
                AutoRoiTopTrackBar.Enabled = false;
            }
            else
            {
                AutoRoiTopTrackBar.Enabled = false;
                AutoRoiTopTrackBar.Enabled = true;
                AutoRoiTopTrackBar.Minimum = _autoRoiTop.RangeMin;
                AutoRoiTopTrackBar.Maximum = _autoRoiTop.RangeMax;
                if (_autoRoiTop.Value > _autoRoiTop.RangeMax) _autoRoiTop.Value = _autoRoiTop.RangeMax;
                if (_autoRoiTop.Value < _autoRoiTop.RangeMin) _autoRoiTop.Value = _autoRoiTop.RangeMin;


                AutoRoiTopTrackBar.Value = _autoRoiTop.Value;
                AutoRoiTopTrackBar.TickFrequency = (AutoRoiTopTrackBar.Maximum - AutoRoiTopTrackBar.Minimum) / 10;
                AutoRoiTopLabel.Text = _autoRoiTop.Value.ToString();
            }

            //I[gtH[JX@Bottom
            _autoRoiBottom = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_AutoRoiBottom);
            if (_autoRoiBottom == null)
            {
                AutoRoiBottomTrackBar.Enabled = false;
            }
            else
            {
                AutoRoiBottomTrackBar.Enabled = false;
                AutoRoiBottomTrackBar.Enabled = true;
                AutoRoiBottomTrackBar.Minimum = _autoRoiBottom.RangeMin;
                AutoRoiBottomTrackBar.Maximum = _autoRoiBottom.RangeMax;
                AutoRoiBottomTrackBar.Value = _autoRoiBottom.Value;
                AutoRoiBottomTrackBar.TickFrequency = (AutoRoiBottomTrackBar.Maximum - AutoRoiBottomTrackBar.Minimum) / 10;
                AutoRoiBottomLabel.Text = _autoRoiBottom.Value.ToString();
            }
            AutoRoiRightTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiLeftTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiTopTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiBottomTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            // CuXg[~OJn
            icImagingControl1.LiveStart();
        }


        private void FocusValueTrackBar_Scroll(object sender, EventArgs e)
        {
            _focusValue.Value = FocusValueTrackBar.Value;
            FocusValueValueLabel.Text = _focusValue.Value.ToString();
        }

        private void FocusAutoMinValueTrackBar_Scroll(object sender, EventArgs e)
        {
            _focusMinValue.Value = FocusAutoMinValueTrackBar.Value;
            FocusAutoMinValueLabel.Text = _focusMinValue.Value.ToString();

        }

        private void FocusAutoMaxValuetrackBar_Scroll(object sender, EventArgs e)
        {
            _focusMaxValue.Value = FocusAutoMaxValuetrackBar.Value;
            FocusAutoMaxValueLabel.Text = _focusMaxValue.Value.ToString();
        }
        private void AutoRoiEnableCheckBox_CheckedChanged( object sender, EventArgs e )
        {
            _autoRoiEnable.Switch = AutoRoiEnableCheckBox.Checked;
            AutoRoiRightTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiLeftTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiTopTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;
            AutoRoiBottomTrackBar.Enabled = AutoRoiEnableCheckBox.Checked;

            AutoRoiRightTrackBar.Value = _autoRoiRight.Value;
            AutoRoiLeftTrackBar.Value = _autoRoiLeft.Value;
            AutoRoiTopTrackBar.Value = _autoRoiTop.Value;
            AutoRoiBottomTrackBar.Value = _autoRoiBottom.Value;
        }



        private void AutoRoiLeftTrackBar_Scroll(object sender, EventArgs e)
        {

            _autoRoiLeft.Value = _autoRoiLeft.Value;
            AutoRoiLeftLabel.Text = _autoRoiLeft.Value.ToString();

        }

        private void AutoRoiRightTrackBar_Scroll( object sender, EventArgs e )
        {
            _autoRoiRight.Value = AutoRoiRightTrackBar.Value;
            AutoRoiRightLabel.Text = _autoRoiRight.Value.ToString();
        }

        private void AutoRoiTopTrackBar_Scroll(object sender, EventArgs e)
        {
            _autoRoiTop.Value = AutoRoiTopTrackBar.Value;
            AutoRoiTopLabel.Text = _autoRoiTop.Value.ToString();
        }
        private void AutoRoiBottomTrackBar_Scroll(object sender, EventArgs e)
        {
            _autoRoiBottom.Value = AutoRoiBottomTrackBar.Value;
            AutoRoiBottomLabel.Text = _autoRoiBottom.Value.ToString();
        }
        private void AutoFocusOnePushButton_Click( object sender, EventArgs e )
        {
            var autoFocusOnePush = icImagingControl1.VCDPropertyItems.Find<VCDButtonProperty>( VCDGUIDs.VCDID_Focus, VCDGUIDs.VCDElement_OnePush );
            if(autoFocusOnePush != null )
            {
                
                autoFocusOnePush.Push();

                AutoFocusOnePushButton.Enabled =false;

                while (true){
                    
                    int oldvalue = _focusValue.Value;
                    System.Threading.Thread.Sleep(1000);
                    FocusValueTrackBar.Value = _focusValue.Value;
                    FocusValueValueLabel.Text = _focusValue.Value.ToString();


                    if (oldvalue == _focusValue.Value)
                    {
                        AutoFocusOnePushButton.Enabled = true;
                        break;
                    }
                    
                }

            }
        }


    }
}